import javax.microedition.lcdui.*;

public class InfoForm extends Form implements CommandListener, Receiver { 
    BrowserCanvas canvas;
    Index         index;
    Location      loc;
    Displayable   parent;

    InfoForm(BrowserCanvas canvas, Index index, Location loc, Displayable parent) { 
        super(loc.name);
        this.canvas = canvas;
        this.index = index;
        this.loc = loc;
        this.parent = parent;
        append(loc.info == null ? Locale.current.getResource("Category") + ": " + Locale.current.getResource(index.name) : loc.info);
        if (loc.image != null) { 
            new InternetConnection(canvas.browser.url + loc.image, this);
        }
        addCommand(MapBrowser.MAP_CMD);
        addCommand(MapBrowser.BACK_CMD);
        setCommandListener(this);
        Display.getDisplay(canvas.browser).setCurrent(this);
    }

    public void received(String url, byte[] body, int len) { 
        try {  
            Image image = Image.createImage(body, 0, len);
            append(new ImageItem(null, image, ImageItem.LAYOUT_DEFAULT, null));
        } catch (Exception e) {}
    }

    public void failure(String url) { 
    }
              
    public void commandAction(Command c, Displayable d) 
    {
        if (c == MapBrowser.BACK_CMD) {
            Display.getDisplay(canvas.browser).setCurrent(parent);
        } else if (c == MapBrowser.MAP_CMD) { 
            canvas.setPositions(index, new Location[]{loc});
            Display.getDisplay(canvas.browser).setCurrent(canvas);
        }            
    }
}
       
